/*
 * Generation of message structure access operations.
 *
 * Copyright (C) 2019 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <stdio.h>
#include "types.h"

void write_accessor_declaration(int input_words, int output_words,
                                char *opname, FILE *fp);

void write_accessor_initialisation(enum specifier direction,
                                   enum component_role component,
                                   char *opname, FILE *fp);

void write_message_access(struct parameter *param, enum component_role component,
                          enum specifier direction, enum parameter_class cls,
                          FILE *fp);
